#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define INT64 "%I64d"
#else
#define INT64 "%lld"
#endif

#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define UNS64 "%I64u"
#else
#define UNS64 "%llu"
#endif
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <cstring>
#include <cassert>
#include <set>
#define SIZE 500005
#define BT 2*512*1024
#define INF 1000000005LL
 
using namespace std;
typedef long long int ll;
 
struct segtree
{
	ll s1[BT];
	int s2[BT];
	bool up[BT];
	int mum;
	
	void init(int n)
	{
		mum=1;
		while(mum<n) mum<<=1;
		memset(s1,0,sizeof(s1));
		memset(s2,0,sizeof(s2));
	}
	void pass(int k)
	{
		if(up[k])
		{
			up[k]=false;
			up[k*2+1]=up[k*2+2]=true;
			s1[k*2+1]=s1[k*2+2]=s1[k]/2;
			s2[k*2+1]=s2[k*2+2]=s2[k];
		}
	}
	void make(int k)
	{
		s1[k]=s1[k*2+1]+s1[k*2+2];
		s2[k]=min(s2[k*2+1],s2[k*2+2]);
	}
	void updata(int a,int b,int k,int l,int r,int v)//[a,b] <= v
	{
		if(b<=l||r<=a) return;
		if(a<=l&&r<=b)
		{
			s1[k]=(ll) v*(r-l);
			s2[k]=v;
			up[k]=true;
		}
		else
		{
			pass(k);
			updata(a,b,k*2+1,l,(l+r)/2,v);
			updata(a,b,k*2+2,(l+r)/2,r,v);
			make(k);
		}
	}
	void updata(int a,int b,ll v)
	{
		updata(a,b,0,0,mum,v);
	}
	int minimum(int a,int b,int k,int l,int r)
	{
		if(b<=l||r<=a) return INF;
		if(a<=l&&r<=b) return s2[k];
		else
		{
			pass(k);
			int vl=minimum(a,b,k*2+1,l,(l+r)/2);
			int vr=minimum(a,b,k*2+2,(l+r)/2,r);
			return min(vl,vr);
		}
	}
	int minimum(int a,int b)
	{
		return minimum(a,b,0,0,mum);
	}
	ll sum(int a,int b,int k,int l,int r)
	{
		if(b<=l||r<=a) return 0;
		if(a<=l&&r<=b) return s1[k];
		else
		{
			pass(k);
			ll vl=sum(a,b,k*2+1,l,(l+r)/2);
			ll vr=sum(a,b,k*2+2,(l+r)/2,r);
			return vl+vr;
		}
	}
	ll sum(int a,int b)
	{
		return sum(a,b,0,0,mum);
	}
	int search(int lim,int h)
	{
		int s=-1,e=lim+1;
		while(e-s>1)
		{
			int med=(s+e)/2;
			if(minimum(0,med+1)>h) s=med;
			else e=med;
		}
		return e;
	}
};
segtree seg;
struct P
{
	int a[3];
	P(int a_=1,int b=0,int c=1)
	{
		a[0]=a_;
		a[1]=b;
		a[2]=c;
	}
};
bool operator<(const P&l,const P&r)
{
	if(l.a[0]!=r.a[0]) return l.a[0]>r.a[0];
	if(l.a[2]!=r.a[2]) return l.a[2]>r.a[2];
	return l.a[1]>r.a[1];
}
bool operator==(const P&l,const P&r)
{
	return l.a[0]==r.a[0]&&l.a[1]==r.a[1]&&l.a[2]==r.a[2];
}
P fish[SIZE];
vector <P> rec;
int n;
 
int main()
{
	scanf("%d",&n);
	for(int i=0;i<n;i++)
	{
		int a;
		char c;
		scanf("%d %c",&a,&c);
		if(c=='R') fish[i]=P(a,0);
		else if(c=='G') fish[i]=P(a,1);
		else fish[i]=P(a,2);
	}
	sort(fish,fish+n);
	P now=P();
	int e=0,sz=0;
	for(int i=0;i<n;i++)
	{
		int bef=e;
		while(e<n&&fish[i].a[0]<fish[e].a[0]*2)
		{
			now.a[fish[e].a[1]]++;
			e++;
		}
		if(bef!=e) rec.push_back(now);
		sz=max(sz,now.a[1]);
		now.a[fish[i].a[1]]--;
	}
	sort(rec.begin(),rec.end());
	rec.erase(unique(rec.begin(),rec.end()),rec.end());
	seg.init(sz+2);
	ll ret=0;
	for(int i=0;i<rec.size();i++)
	{
		int a=rec[i].a[0],b=rec[i].a[1],c=rec[i].a[2];
		int p=seg.search(b,c);
		if(p<=b)
		{
			ll sum=seg.sum(p,b+1);
			ret+=(ll) a*((ll) (b-p+1)*c-sum);
			seg.updata(p,b+1,c);
		}
	}
	printf(INT64 "\n",ret-1);
	return 0;
}
