#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define INT64 "%I64d"
#else
#define INT64 "%lld"
#endif

#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define UNS64 "%I64u"
#else
#define UNS64 "%llu"
#endif
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <cstring>
#include <queue>
#define SIZE 400005
#define BT 512*1024*2
 
using namespace std;
typedef long long int ll;
typedef pair <int,int> P;
 
struct segtree
{
	int wh[BT],bl[BT];
	bool flip[BT];
	int mum;
	
	void init(int n)
	{
		mum=1;
		while(mum<n) mum<<=1;
		for(int i=0;i<mum*2;i++)
		{
			flip[i]=false;
			wh[i]=bl[i]=0;
		}
	}
	void add(int k,int x)
	{
		k+=mum-1;
		wh[k]=x;bl[k]=0;
		while(k>0)
		{
			k=(k-1)/2;
			make(k);
		}
	}
	void make(int k)
	{
		wh[k]=wh[k*2+1]+wh[k*2+2];
		bl[k]=bl[k*2+1]+bl[k*2+2];
		if(flip[k]) swap(wh[k],bl[k]);
	}
	void update(int a,int b,int k,int l,int r)
	{
		if(r<=a||b<=l) return;
		if(a<=l&&r<=b)
		{
			swap(wh[k],bl[k]);
			flip[k]=!flip[k];
		}
		else
		{
			update(a,b,k*2+1,l,(l+r)/2);
			update(a,b,k*2+2,(l+r)/2,r);
			make(k);
		}
	}
	void update(int a,int b)
	{
		update(a,b,0,0,mum);
	}
	int vl()
	{
		return wh[0];
	}
};
segtree seg;
int A[SIZE],B[SIZE],C[SIZE],D[SIZE];
vector <int> vx,vy;
vector <P> event[SIZE];
 
int main()
{
	int m,n,k;
	scanf("%d %d %d",&m,&n,&k);
	vx.push_back(0);
	vx.push_back(n);
	vy.push_back(0);
	vy.push_back(m);
	for(int i=0;i<k;i++)
	{
		scanf("%d %d %d %d",&A[i],&B[i],&C[i],&D[i]);
		A[i]--;B[i]--;C[i]--;D[i]--;
		vx.push_back(C[i]);
		vx.push_back(D[i]+1);
		vy.push_back(A[i]);
		vy.push_back(B[i]+1);
	}
	sort(vx.begin(),vx.end());
	vx.erase(unique(vx.begin(),vx.end()),vx.end());
	sort(vy.begin(),vy.end());
	vy.erase(unique(vy.begin(),vy.end()),vy.end());
	seg.init(vx.size()+2);
	for(int i=0;i+1<vx.size();i++)
	{
		seg.add(i,vx[i+1]-vx[i]);
	}
	for(int i=0;i<k;i++)
	{
		int s=lower_bound(vx.begin(),vx.end(),C[i])-vx.begin();
		int t=lower_bound(vx.begin(),vx.end(),D[i]+1)-vx.begin();
		int p=lower_bound(vy.begin(),vy.end(),A[i])-vy.begin();
		int q=lower_bound(vy.begin(),vy.end(),B[i]+1)-vy.begin();
		event[p].push_back(P(s,t));
		event[q].push_back(P(s,t));
	}
	ll ret=0;
	for(int i=0;i+1<vy.size();i++)
	{
		for(int j=0;j<event[i].size();j++)
		{
			P p=event[i][j];
			seg.update(p.first,p.second);
		}
		ret+=(ll) (vy[i+1]-vy[i])*(ll) seg.vl();
	}
	printf(INT64 "\n",ret);
	return 0;
}
