#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define INT64 "%I64d"
#else
#define INT64 "%lld"
#endif

#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define UNS64 "%I64u"
#else
#define UNS64 "%llu"
#endif
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <cstring>
#include <queue>
#define SIZE 1005
#define MX 1000005
 
using namespace std;
typedef long long int ll;
typedef pair <int,int> P;
 
int dx[4]={1,0,-1,0},dy[4]={0,1,0,-1};
//vector <int> gt[MX*4];
int gt[MX*4][5],now[MX*4];
char mp[SIZE][SIZE];
int low[MX],ord[MX],cnt[MX],mch[MX];
bool use[MX],ok[MX*4];
P edge[MX*2];
int sz,E;
int n,m;
int gx,gy;
 
int id(int x,int y)
{
	return x*m+y;
}
bool valid(int x,int y)
{
	return 0<=x&&x<n&&0<=y&&y<m&&mp[x][y]!='#';
}
void dfs(int x,int y,int p)
{
	int v=id(x,y);
	use[v]=true;
	low[v]=ord[v]=sz++;
	cnt[v]=1;
	for(int i=0;i<4;i++)
	{
		int nx=x+dx[i],ny=y+dy[i];
		if(valid(nx,ny))
		{
			int to=id(nx,ny);
			if(to==p) continue;
			if(!use[to])
			{
				dfs(nx,ny,v);
				cnt[v]+=cnt[to];
				if(p!=-1) edge[E++]=P(v,to);
				edge[E++]=P(to,v);
				low[v]=min(low[v],low[to]);
			}
			else
			{
				low[v]=min(low[v],ord[to]);
			}
		}
	}
	mch[v]=sz;
}
bool bridge(int s,int t)
{
	if(ord[s]>ord[t]) swap(s,t);//ord[s]<=ord[t]
	return low[t]>ord[s];
}
int get(int s,int t)//s->t
{
	if(cnt[s]>cnt[t]) return cnt[t];
	else return sz-cnt[s]-1;//except rt
}
bool inter(int p,int tg)
{
	return ord[p]<ord[tg]&&ord[tg]<mch[p];
}
int main()
{
	scanf("%d %d",&n,&m);
	for(int i=0;i<n;i++) scanf("%s",&mp[i]);
	for(int i=0;i<n;i++)
	{
		for(int j=0;j<m;j++)
		{
			if(mp[i][j]=='X')
			{
				gx=i;
				gy=j;
				break;
			}
		}
	}
	sz=0;
	dfs(gx,gy,-1);
	for(int i=0;i<n;i++)
	{
		for(int j=0;j<m;j++)
		{
			int v=id(i,j);
			if(use[v])
			{
				for(int k=0;k<4;k++)
				{
					int x=i+dx[k],y=j+dy[k];
					if(valid(x,y))
					{
						//(i,j)->(x,y)->(nx,ny)
						int nx=x+dx[k],ny=y+dy[k];
						if(valid(nx,ny))
						{
							//gt[v*4+k].push_back(id(x,y)*4+k); reverse!!
							//gt[id(x,y)*4+k].push_back(v*4+k);
							gt[id(x,y)*4+k][now[id(x,y)*4+k]++]=v*4+k;
						}
						int to=id(x,y);
						if(ord[v]<ord[to])
						{
							for(int p=0;p<4;p++)
							{
								nx=x+dx[p],ny=y+dy[p];
								if(valid(nx,ny))
								{
									int T=id(nx,ny);
									if(T==v) continue;
									if(low[T]<ord[to])
									{
										//(v->to) -> (T->to)
										int pl=p^2;
										//gt[v*4+k].push_back(T*4+pl); reverse!!
										//gt[T*4+pl].push_back(v*4+k);
										gt[T*4+pl][now[T*4+pl]++]=v*4+k;
									}
								}
							}
						}
						else
						{
							for(int p=0;p<4;p++)
							{
								nx=x+dx[p],ny=y+dy[p];
								if(valid(nx,ny))
								{
									int T=id(nx,ny);
									if(T==v) continue;
									if((ord[T]>ord[to]&&ord[v]>ord[to]&&(inter(v,T)||inter(T,v)))||(low[v]<ord[to]&&low[T]<ord[to]))
									{
										//(v->to) -> (T->to)
										int pl=p^2;
										//gt[v*4+k].push_back(T*4+pl); reverse!!
										//gt[T*4+pl].push_back(v*4+k);
										gt[T*4+pl][now[T*4+pl]++]=v*4+k;
									}
								}
							}
						}
					}
				}
			}
		}
	}
	queue <int> que;
	for(int k=0;k<4;k++)
	{
		int x=gx+dx[k],y=gy+dy[k];
		if(valid(x,y))
		{
			int pl=k^2;
			que.push(id(x,y)*4+pl);
			ok[id(x,y)*4+pl]=true;
		}
	}
	while(!que.empty())
	{
		int v=que.front();que.pop();
		for(int i=0;i<now[v];i++)
		{
			int to=gt[v][i];
			if(!ok[to])
			{
				ok[to]=true;
				que.push(to);
			}
		}
	}
	ll ret=0;
	for(int i=0;i<E;i++)
	{
		P p=edge[i];
		int v=p.first,vl=p.second;
		int x1=v/m,y1=v%m;
		int x2=vl/m,y2=vl%m;
		int dr;
		for(dr=0;dr<4;dr++)
		{
			if(x2+dx[dr]==x1&&y2+dy[dr]==y1)
			{
				break;
			}
		}
		if(ok[vl*4+dr])
		{
			ret+=get(v,vl);
		}
	}
	printf(INT64 "\n",ret);
	return 0;
}
